#version 330 core

layout(location = 0) in vec3 squareVertices;
layout(location = 1) in vec4 xyzs;
layout(location = 2) in vec4 color;

out vec2 UV;
out vec4 particlecolor;

uniform vec3 camRightWorld;
uniform vec3 camUpWorld;
uniform mat4 VP;

void main()
{
	float size = xyzs.w;
	vec3 pCenterWorld = xyzs.xyz;
	vec3 posWorld = pCenterWorld + camRightWorld * squareVertices.x * size + camUpWorld * squareVertices.y * size;
	gl_Position = VP * vec4(posWorld, 1.0f);
	UV = squareVertices.xy + vec2(0.5, 0.5);
	particlecolor = color;
}

