#version 330 core

in vec3 position;
in vec2 uv;
in vec3 normal;

out vec2 UV;
out vec3 positionWorld;
out vec3 normalCam;
out vec3 lightDirCam;
out vec3 eyeDirCam;

uniform mat4 P;
uniform mat4 V;
uniform mat4 M;
uniform vec3 lightPosWorld;

//Shadow:
out vec4 shadowCoord;
uniform mat4 depthBiasVP;

void main(){

	mat4 depthBiasMVP = depthBiasVP * M;
	shadowCoord = depthBiasMVP * vec4(position, 1);

	mat4 MVP = P * V * M;
	gl_Position =  MVP * vec4(position, 1);
	
	positionWorld = (M * vec4(position, 1)).xyz;
	
	vec3 positionCam = (V * M * vec4(position, 1)).xyz;
	eyeDirCam = vec3(0,0,0) - positionCam;
	vec3 lighPosCam = (V * vec4(lightPosWorld, 1)).xyz;
	lightDirCam = lighPosCam + eyeDirCam;
	
	normalCam = (V * M * vec4(normal, 0)).xyz;

	UV = uv;
}

